summaryrefslogtreecommitdiffstats
path: root/wpa_actiond
diff options
context:
space:
mode:
authorJames Rayner <james@archlinux.org>2009-09-27 15:45:41 +0200
committerJames Rayner <james@archlinux.org>2009-09-27 15:45:41 +0200
commitdf2c2b5c04393ed72c2798407f50f99a6298b673 (patch)
treec432706c3b31ff5702217ec0d16edb4ecae11b0b /wpa_actiond
parent818dacfa7f435e42fe1c81ae002a8df01ea80677 (diff)
downloadnetctl-df2c2b5c04393ed72c2798407f50f99a6298b673.tar.gz
netctl-df2c2b5c04393ed72c2798407f50f99a6298b673.tar.xz
Rename autowifi->wpa_actiond, add makefile, bugfix
Diffstat (limited to 'wpa_actiond')
-rwxr-xr-xwpa_actiond/netcfg-wpa_actiond54
-rwxr-xr-xwpa_actiond/netcfg-wpa_actiond-action54
2 files changed, 108 insertions, 0 deletions
diff --git a/wpa_actiond/netcfg-wpa_actiond b/wpa_actiond/netcfg-wpa_actiond
new file mode 100755
index 0000000..02901c6
--- /dev/null
+++ b/wpa_actiond/netcfg-wpa_actiond
@@ -0,0 +1,54 @@
+
+. /usr/lib/network/network
+. /usr/lib/network/8021x
+. /usr/lib/network/wireless
+
+interface=$1; shift
+
+AUTOWIFI="/usr/sbin/wpa_actiond"
+ACTION_SCRIPT="/usr/bin/netcfg-wpa_actiond-action"
+PIDFILE="/var/run/wpa_supplicant_${interface}.pid"
+EXTRA_AUTOWIFI_OPTIONS="$*"
+
+if [[ -z $interface ]]; then
+ echo "No interface specified"
+ exit 1
+fi
+
+# Load interface specific config
+[[ -f "$IFACE_DIR/$interface" ]] && source "$IFACE_DIR/$interface"
+
+if [[ -n "$RFKILL" ]]; then # Enable radio if necessary
+ set_rf_state "$interface" up || exit $?
+fi
+
+WPA_CONF="$(make_wpa_config_file $interface)"
+
+for profile in $(list_profiles); do
+ echo $profile
+ (
+ load_profile $profile
+
+ [[ $CONNECTION != "wireless" ]] && exit 1
+ [[ $INTERFACE != $interface ]] && exit 1
+
+ config=$(make_wpa_config)
+
+ echo -e "network={ \n$config \nid_str=\"$profile\" \n}" >> $WPA_CONF
+ )
+done
+
+
+[[ -z $WPA_DRIVER ]] && WPA_DRIVER="wext"
+
+# Kill any existing wpa_supplicant on this interface
+stop_wpa "$interface"
+
+if start_wpa $interface $WPA_CONF $WPA_DRIVER $WPA_OPTS; then
+ if $AUTOWIFI -i ${interface} -P {PIDFILE} -a ${ACTION_SCRIPT} ${EXTRA_AUTOWIFI_OPTIONS}; then
+ exit 0
+ fi
+fi
+
+exit 1
+
diff --git a/wpa_actiond/netcfg-wpa_actiond-action b/wpa_actiond/netcfg-wpa_actiond-action
new file mode 100755
index 0000000..f273b3b
--- /dev/null
+++ b/wpa_actiond/netcfg-wpa_actiond-action
@@ -0,0 +1,54 @@
+#! /bin/bash
+
+interface=$1
+ssid=$2
+profile=$3
+action=$4
+
+. /usr/lib/network/network
+[[ $profile ]] && load_profile "$profile"
+
+case $action in
+ CONNECT)
+ if [[ -z $profile ]]; then
+ dhcpcd $interface
+ exit $?
+ fi
+ if ! $CONN_DIR/ethernet up "$profile"; then
+ exit 1 # what to do if fail?
+ fi
+
+ set_profile up "$profile"
+
+ if ! ( eval $POST_UP ); then # JP: sandbox the eval
+ # failing POST_UP will take interface down
+ "$CONN_DIR/$ethernet" down "$profile"
+ exit 1
+ fi
+ ;;
+ DISCONNECT)
+ if [[ -z $profile ]]; then
+ dhcpcd -k $interface
+ exit $?
+ fi
+ if ! ( eval $PRE_DOWN ); then # JP: sandbox the eval
+ exit 1
+ fi
+ if ! "$CONN_DIR/ethernet" down "$profile"; then
+ exit 1
+ fi
+ if ! ( eval $POST_DOWN ); then # JP: sandbox the eval
+ exit 1
+ fi
+ set_profile down "$profile"
+ ;;
+ LOST|REESTABLISHED)
+ # Not handled.
+ exit 0
+ ;;
+ *)
+ # ???
+ exit 1
+ ;;
+esac
+